-- -----------------------------------------------------------------------------

local ADDON_NAME, ns = ...
local WOEZ_D,WOEZ_O,WOEZ_F = ns.datas,ns.functions,ns.frames

-- -----------------------------------------------------------------------------

local Options = CreateFrame("Frame", "WOEZOptions", InterfaceOptionsFramePanelContainer)
      Options.name = "WOEZ Calendar Invit" 
      Options:Hide()
InterfaceOptions_AddCategory(Options)

-- -----------------------------------------------------------------------------
-- -----------------------------------------------------------------------------

Options:SetScript("OnShow", function(self)
    WOEZ_O:DEBUG('OPTIONS','','OnShow')
    WOEZ_O:GET_GUILD() 

    local Title = self:CreateFontString("WOEZ_OPT_Title", "ARTWORK", "GameFontNormalLarge")
          Title:SetPoint("TOPLEFT", 16, -16)
          Title:SetText(self.name)

    local Version = WOEZ_O:FONT("WOEZ_OPT_Version",self,"TOPLEFT", Title    , "BOTTOMLEFT", 0, -8,          nil,nil,"GameFontHighlightSmall","LEFT")
          Version:SetText("Easy manage guild invitations to calendar")


    function addbtn(name,value,text,textb) 
        local line = WOEZ_O:FRAM("WOEZ_OPT_"..name,"CheckButton",self,"ChatConfigCheckButtonTemplate",nil,nil,nil,nil,nil,nil,WOEZ_D.fonts.TXT_14,WOEZ_D.fonts.TXT_14)
        local line_txt = WOEZ_O:FONT("WOEZ_OPT_"..name.."_txt",line,"LEFT",line,"RIGHT",WOEZ_D.sizes.MMARGS,0, nil,nil,WOEZ_D.fonts.TTL_F,"LEFT")
              line_txt:SetText(text)   
              line_txt:SetTextColor(1,1,1,1)         
        if textb then         
            local line_bis = WOEZ_O:FRAM("WOEZ_OPT_"..name.."b","CheckButton",self,"ChatConfigCheckButtonTemplate",nil,nil,nil,nil,nil,nil,WOEZ_D.fonts.TXT_14,WOEZ_D.fonts.TXT_14)
            local line_txt_bis = WOEZ_O:FONT("WOEZ_OPT_"..name.."_txtb",line_bis,"LEFT",line_bis,"RIGHT",WOEZ_D.sizes.MMARGS,0, nil,nil,WOEZ_D.fonts.TTL_F,"LEFT")
                  line_txt_bis:SetText(textb)   
                  line_txt_bis:SetTextColor(1,1,1,1) 
            if value then line:SetChecked(true) line_bis:SetChecked(false) else line:SetChecked(false) line_bis:SetChecked(true) end                
            return line,line_txt,line_bis,line_txt_bis
        else
            if value then line:SetChecked(true) else line:SetChecked(false) end
            return line,line_txt
        end        
    end


    function self:refresh()
        WOEZ_O:DEBUG('OPTIONS','','Refresh')
        local HShowRank = -40

    --    -- -----------------------------------------------------------------------------------------------------
    --    -- -----------------------------------------------------------------------------------------------------
    --    -- -----------------------------------------------------------------------------------------------------

        if WOEZ_D.InGuild then
            
            -- get list guild rank
            local infos = {}            
            for i=2, GuildControlGetNumRanks() do
                local Nameg = GuildControlGetRankName(i)
                if Nameg then infos[i] = Nameg end
            end

            local ShowGMrank = WOEZ_O:FONT("WOEZ_OPT_GM",self,  "TOPLEFT", Version, "BOTTOMLEFT", 23, HShowRank,   nil,nil,"GameFontNormal","LEFT")
                  ShowGMrank:SetText("Show GuildMaster as :")

            HShowRank = HShowRank -16

            local infos = {}            
            for i=2, GuildControlGetNumRanks() do
                local Nameg = GuildControlGetRankName(i)
                if Nameg then infos[i] = Nameg end
            end
            local obj = "WOEZ_OPT_GMR"
            local GMRankDropdown = _G[obj] or CreateFrame("Frame",obj, self, "UIDropDownMenuTemplate")
                  GMRankDropdown:SetPoint("LEFT", ShowGMrank, "RIGHT", 0, -2)
                  GMRankDropdown.initialize = function()
                        info = {}
                        for u, grank in pairs(infos) do
                            info.text = grank
                            info.value = u
                            info.func = function(self)
                                WO_ez_DBC.guildrankGM = self.value
                                info.checked = self.value == self.text 
                                UIDropDownMenu_SetText(GMRankDropdown, self:GetText()) 
                                WOEZ_O:SET_ROSTER()
                            end
                            info.checked = u == WO_ez_DBC.guildrankGM
                            UIDropDownMenu_AddButton(info)
                        end
                  end
            if infos[WO_ez_DBC.guildrankGM] then UIDropDownMenu_SetText(GMRankDropdown, infos[WO_ez_DBC.guildrankGM]) end
            GMRankDropdown:Show()

            HShowRank = HShowRank-26

        end

    --    -- -----------------------------------------------------------------------------------------------------
    --    -- -----------------------------------------------------------------------------------------------------
    --    -- -----------------------------------------------------------------------------------------------------

        local InfosZ1 = WOEZ_O:FONT("WOEZ_OPT_DP",self,"TOPLEFT", Version,"BOTTOMLEFT",23,HShowRank,nil,nil,"GameFontNormal","LEFT")
              InfosZ1:SetText("Display :")
        HShowRank = HShowRank-20

        -- ------------------------------------------------------- ON enable_ilevl

        local line_WOEZ_OPT_NO,line_WOEZ_OPT_NOt = addbtn("NO",WO_ez_DBC.enable_notes,"Note column") 
              line_WOEZ_OPT_NO:SetPoint("TOPLEFT",Version,"BOTTOMLEFT",22,HShowRank)
              line_WOEZ_OPT_NO:SetScript("OnClick", function(self, button) if self:GetChecked() then WO_ez_DBC.enable_notes = true else WO_ez_DBC.enable_notes = false end WOEZ_O:SET_ROSTER() end)  
        
        -- ------------------------------------------------------- ON enable_noteo

        local line_WOEZ_OPT_NF,line_WOEZ_OPT_NFt = addbtn("NF",WO_ez_DBC.enable_noteo,"Officer's notes text instead of public notes") 
              line_WOEZ_OPT_NF:SetPoint("LEFT",line_WOEZ_OPT_NO,"RIGHT",140,0)
              line_WOEZ_OPT_NF:SetScript("OnClick", function(self, button) if self:GetChecked() then WO_ez_DBC.enable_noteo = true else WO_ez_DBC.enable_noteo = false end WOEZ_O:SET_ROSTER() end)  
        
        HShowRank = HShowRank-26

        -- ------------------------------------------------------- ON enable_ilevl

        local line_WOEZ_OPT_IL,line_WOEZ_OPT_ILt = addbtn("IL",WO_ez_DBC.enable_ilevl,"Level column") 
              line_WOEZ_OPT_IL:SetPoint("TOPLEFT",Version,"BOTTOMLEFT",22,HShowRank)
              line_WOEZ_OPT_IL:SetScript("OnClick", function(self, button) if self:GetChecked() then WO_ez_DBC.enable_ilevl = true else WO_ez_DBC.enable_ilevl = false end WOEZ_O:SET_ROSTER() end)  

        -- ------------------------------------------------------- ON enable_ilevf

        local line_WOEZ_OPT_IF,line_WOEZ_OPT_IFt = addbtn("IF",WO_ez_DBC.enable_ilevf,"Fade lower level") 
              line_WOEZ_OPT_IF:SetPoint("LEFT",line_WOEZ_OPT_IL,"RIGHT",140,0)
              line_WOEZ_OPT_IF:SetScript("OnClick", function(self, button) if self:GetChecked() then WO_ez_DBC.enable_ilevf = true else WO_ez_DBC.enable_ilevf = false end WOEZ_O:SET_ROSTER() end)  
        
        HShowRank = HShowRank-26

        -- ------------------------------------------------------- ON enable_summa

    --    local line_WOEZ_OPT_SM,line_WOEZ_OPT_IFt = addbtn("SM",WO_ez_DBC.enable_summa,"Enable summary") 
    --          line_WOEZ_OPT_SM:SetPoint("TOPLEFT",Version,"BOTTOMLEFT",22,HShowRank)
    --          line_WOEZ_OPT_SM:SetScript("OnClick", function(self, button) if self:GetChecked() then WO_ez_DBC.enable_summa = true else WO_ez_DBC.enable_summa = false end WOEZ_O:SET_ROSTER() end)  
    --    
    --    HShowRank = HShowRank-56
        
    --    -- -----------------------------------------------------------------------------------------------------
    --    -- -----------------------------------------------------------------------------------------------------
    --    -- -----------------------------------------------------------------------------------------------------

        local InfosZ2 = WOEZ_O:FONT("WOEZ_OPT_RO",self,"TOPLEFT", Version,"BOTTOMLEFT",23,HShowRank,nil,nil,"GameFontNormal","LEFT")
              InfosZ2:SetText("Roles :")
        HShowRank = HShowRank-20

        -- ------------------------------------------------------- ON enable_icons

        local line_WOEZ_OPT_IC,line_WOEZ_OPT_ICt = addbtn("IC",WO_ez_DBC.enable_icons,"Roles icons") 
              line_WOEZ_OPT_IC:SetPoint("TOPLEFT",Version,"BOTTOMLEFT",22,HShowRank)
              line_WOEZ_OPT_IC:SetScript("OnClick", function(self, button) if self:GetChecked() then WO_ez_DBC.enable_icons = true else WO_ez_DBC.enable_icons = false end WOEZ_O:SET_ROSTER() end)  

        local enableIC_inf = WOEZ_O:FONT("WOEZ_OPT_IC_inf",line_WOEZ_OPT_IC,"LEFT",line_WOEZ_OPT_IC,"LEFT",WOEZ_D.sizes.MMARGS,-20, nil,nil,"GameFontHighlightSmall","LEFT")
              enableIC_inf:SetText('Add one of these words in the public (or officer) note to see them: "TANK HEAL MELEE RANGE"')   
              enableIC_inf:SetTextColor(1,1,1,.4) 
        local enableIC_inb = WOEZ_O:FONT("WOEZ_OPT_IC_inb",line_WOEZ_OPT_IC,"LEFT",line_WOEZ_OPT_IC,"LEFT",WOEZ_D.sizes.MMARGS,-34, nil,nil,"GameFontHighlightSmall","LEFT")
              enableIC_inb:SetText('You can bypass note by clicking on icon ( Click order give : Melee > Range > Heal > Tank > None )')   
              enableIC_inb:SetTextColor(1,1,1,.4)               
        HShowRank = HShowRank-48

        local line_WOEZ_OPT_IO,line_WOEZ_OPT_IOt = addbtn("IO",WO_ez_DBC.enable_icnof,"Search in officer's notes instead of public notes") 
              line_WOEZ_OPT_IO:SetPoint("LEFT",line_WOEZ_OPT_IC,"RIGHT",140,0)
              line_WOEZ_OPT_IO:SetScript("OnClick", function(self, button) if self:GetChecked() then WO_ez_DBC.enable_icnof = true else WO_ez_DBC.enable_icnof = false end WOEZ_O:SET_ROSTER() end)  
        HShowRank = HShowRank-36



        local InfosZ3 = WOEZ_O:FONT("WOEZ_OPT_PP",self,  "TOPLEFT", Version, "BOTTOMLEFT", 23, HShowRank,   nil,nil,"GameFontNormal","LEFT")
              InfosZ3:SetText("Private list :")
        HShowRank = HShowRank-20

        -- ------------------------------------------------------- ON pvate_totop 
        local line_WOEZ_OPT_PVT,line_WOEZ_OPT_PVTt,line_WOEZ_OPT_PVB,line_WOEZ_OPT_PVBt = addbtn("PVT",WO_ez_DBC.pvate_totop,"View at the top","Bottom of the list") 
              line_WOEZ_OPT_PVT:SetPoint("TOPLEFT",Version,"BOTTOMLEFT",22,HShowRank)
              line_WOEZ_OPT_PVB:SetPoint("LEFT",line_WOEZ_OPT_PVT,"RIGHT",140,0)
              line_WOEZ_OPT_PVT:SetScript("OnClick", function(self, button) if self:GetChecked() then WO_ez_DBC.pvate_totop = true  line_WOEZ_OPT_PVB:SetChecked(false) else WO_ez_DBC.pvate_totop = false line_WOEZ_OPT_PVB:SetChecked(true) end WOEZ_O:SET_ROSTER() end)  
              line_WOEZ_OPT_PVB:SetScript("OnClick", function(self, button) if self:GetChecked() then WO_ez_DBC.pvate_totop = false line_WOEZ_OPT_PVT:SetChecked(false) else WO_ez_DBC.pvate_totop = true  line_WOEZ_OPT_PVT:SetChecked(true) end WOEZ_O:SET_ROSTER() end)  
    
        HShowRank = HShowRank-30

        -- ------------------------------------------------------- ON pvate_list

        local InfosZ4 = WOEZ_O:FONT("WOEZ_OPT_PN",self,  "TOPLEFT", Version, "BOTTOMLEFT", 26, HShowRank,   nil,nil,"GameFontHighlight","LEFT")
              InfosZ4:SetText("Title:")

        local obj = "WOEZ_OPT_namePV"
        local namePV = _G[obj] or CreateFrame("EditBox",obj, self, "InputBoxTemplate")
              namePV:SetPoint("LEFT", InfosZ4, "RIGHT",11,0)
              namePV:SetSize(333, 20)
              namePV:SetAutoFocus(false)
              namePV:SetScript("OnKeyUp", function(self) WO_ez_DBC.pvate_name = self:GetText() WOEZ_O:SET_ROSTER() end)    
              namePV:SetText(WO_ez_DBC.pvate_name) 
              namePV:Show()

    end
    self:refresh()
    self:SetScript("OnShow", nil)
end)


-- -----------------------------------------------------------------------------
-- options options
-- -----------------------------------------------------------------------------

SLASH_WOEZ1 = "/woez"
SlashCmdList.WOEZ = function()
	InterfaceOptionsFrame_OpenToCategory(Options)
    InterfaceOptionsFrame_OpenToCategory(Options)
end

-- -----------------------------------------------------------------------------